/*
 * Skytils - Hypixel Skyblock Quality of Life Mod
 * Copyright (C) 2022 Skytils
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package gg.skytils.skytilsmod.commands.impl

import gg.essential.universal.UChat
import gg.skytils.skytilsmod.Skytils
import gg.skytils.skytilsmod.Skytils.Companion.client
import gg.skytils.skytilsmod.Skytils.Companion.mc
import gg.skytils.skytilsmod.commands.BaseCommand
import io.ktor.client.call.*
import io.ktor.client.plugins.*
import io.ktor.client.request.*
import io.ktor.client.statement.*
import io.ktor.http.*
import kotlinx.coroutines.launch
import kotlinx.serialization.json.JsonObject
import net.minecraft.client.entity.EntityPlayerSP
import java.util.*

object FragBotCommand : BaseCommand("fragbot") {
    override fun processCommand(player: EntityPlayerSP, args: Array<String>) {
        Skytils.IO.launch {
            val serverId = UUID.randomUUID().toString().replace("-".toRegex(), "")
            mc.sessionService.joinServer(mc.session.profile, mc.session.token, serverId)
            val response =
                client.get("https://${Skytils.domain}/api/fragbots/get?uuid=${player.uniqueID}&username=${player.name}&serverId=${serverId}") {
                    expectSuccess = false
                }
            if (response.status == HttpStatusCode.OK) {
                Skytils.sendMessageQueue.add("/party invite ${response.bodyAsText()}")
            } else {
                UChat.chat("${Skytils.failPrefix} §c${response.body<JsonObject>()["message"]}")
            }
        }
    }
}
